package Team5.SmartTowns.Organisation;

import Team5.SmartTowns.Data.Location;
import Team5.SmartTowns.addTowns.addAddTowns;
import Team5.SmartTowns.addTowns.addAddTownsRepository;
import Team5.SmartTowns.Towns.Towns;
import jakarta.validation.Valid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.List;

@Controller
public class organisationControllers {
    @GetMapping("/localauthorities")
    public ModelAndView getLocalAuthoritiesPage() {
        ModelAndView modelAndView = new ModelAndView("WorkWith/local-authorities.html");
        return modelAndView;
    }

    @GetMapping("/businesses")
    public ModelAndView getBusinessPage() {
        ModelAndView modelAndView = new ModelAndView("WorkWith/business.html");
        return modelAndView;
    }

    @GetMapping("/consumers")
    public ModelAndView getConsumersPage() {
        ModelAndView modelAndView = new ModelAndView("WorkWith/consumers.html");
        return modelAndView;
    }

    @GetMapping("/towns")
    public ModelAndView getTownsPage() {
        ModelAndView modelAndView = new ModelAndView("towns");
        List<addAddTowns> Towns = addAddTownsRepository.getAllAddTowns();
        modelAndView.addObject("towns", Towns);
        return modelAndView;
    }
    @GetMapping("/townForm")
    public ModelAndView getLocalAuthPage(){
        ModelAndView modelAndView = new ModelAndView("towns-data");
        modelAndView.addObject("addAddTowns",new addAddTowns());
        return modelAndView;
    }

    @Autowired
    private addAddTownsRepository addAddTownsRepository;

    @PostMapping("/towns-data")
    public ModelAndView townsSent(@Valid @ModelAttribute("towns-data") addAddTowns towns, BindingResult bindingResult, Model model) {
        List<addAddTowns> addtowns = addAddTownsRepository.getAllAddTowns();

        if (bindingResult.hasErrors()) {
            ModelAndView modelAndView = new ModelAndView("towns-data", model.asMap());
            return modelAndView;
        } else {// converts user input using the organisation constructor into a submittable format to the sql table

            addAddTowns tow = new addAddTowns(towns.getTownName(), towns.getAddress1(), towns.getAddress2(), towns.getCity(), towns.getCounty(), towns.getPostcode());
            System.out.println(tow);
            addAddTownsRepository.addTown(tow); //add new towns to Add Towns table
            ModelAndView modelAndView = new ModelAndView("redirect:/businesses");
            return modelAndView;
        }
    }
}
